--- old/obj/functions.c	2010-08-12 15:23:42.000000000 -0700
+++ new/obj/functions.c	2017-05-25 12:44:20.941407146 -0700
@@ -380,6 +380,23 @@
 	if(!o) return(1);
 	DECREF(o);
 
+// (define (hexchar? c) (ifelse (and (<= 48 c) (<= c 57)) (- c 48) (ifelse (and (<= 65 c) (<= c 70)) (- c 55) (ifelse (and (<= 97 c) (<= c 102)) (- c 87) #f))))
+// (#define 'hexchar? (byte-compile '(c) '(#ifelse (#and (<= 48 c) '(<= c 57)) '(- c 48) '(#ifelse (#and (<= 65 c) '(<= c 70)) '(- c 55) '(#ifelse (#and (<= 97 c) '(<= c 102)) '(- c 87) '#f)))))
+// (#lambda "\x81#\xB0i\x81I\x83?I\x86\x46\x44I\xB9i\x83?\x86\x46I\xB0i-\xB4G\x80\xC1i\x81I\x83?I\x87\x46\x44I\x80\xC6i\x83?\x86\x46I\xB7i-\x9BG\x80\xE1i\x81I\x83?I\x87\x46\x44I\x80\xE6i\x83?\x87\x46I\x80\xD7i-\x81G0\x81R" '#f)
+// (#lambda "\x81#\xB0i\x81I\x83?I\x86\x46\x44I\xB9i\x83?\x84\x46\xB0i-R\x80\xC1i\x81I\x83?I\x87\x46\x44I\x80\xC6i\x83?\x84\x46\xB7i-R\x80\xE1i\x81I\x83?I\x87\x46\x44I\x80\xE6i\x83?\x85\x46\x80\xD7i-RD0R" '#f)
+	s=new_string("\x81#\xB0i\x81I\x83?I\x86\x46\x44I\xB9i\x83?\x84\x46\xB0i-R\x80\xC1i\x81I\x83?I\x87\x46\x44I\x80\xC6i\x83?\x84\x46\xB7i-R\x80\xE1i\x81I\x83?I\x87\x46\x44I\x80\xE6i\x83?\x85\x46\x80\xD7i-RD0R",73);
+	if(!s) return(1);
+	c=INCREF(&nilobj);
+	o=new_object(&bytefunc_objtype);
+	if(!o) return(1);
+	o->value.bytefunc.code=s;
+	o->value.bytefunc.objs=c;
+	s=new_word("hexchar?",8);
+	if(!s) return(1);
+	o=define(s,o);
+	if(!o) return(1);
+	DECREF(o);
+
 // (define (skip-whitespace stream) (loop (let ((c (peek-char stream))) (if (= 59 c) (while (and (<> c 10) (<> c 13)) (set c (read-char stream))) (next-loop)) (unless (is-space c) (exit-loop c)) (read-char stream))))
 // (#define 'skip-whitespace (byte-compile '(stream) '(#loop '(#let 'c (peek-char stream) '(#prog2of2 (#ifelse (= 59 c) '(#prog2of2 (#loop '(#ifelse (#and (<> c 10) '(<> c 13)) '(#set 'c (read-char stream)) '(#exit-loop #f))) '(#next-loop)) '#f) '(#prog2of2 (#ifelse (is-space c) '#f '(#exit-loop c)) '(read-char stream)))))))
 // (#lambda "\x81#ILl\x81\x43\xBBi\x81I\x82?\xA8\x46I\x8Ai\x85?I\x86\x46\x44I\x8Di\x85?\x8C\x46\x81I\x81Ll\x81\x43I\x81P\x83G0\x83GD\xDEGDD\xCDG\x81G0DI\x82Ll\x81\x43\x83\x46\x30\x84GIP\x8DGD\x81I\x81Ll\x81\x43PD\xFF\xADG\x81R" '(peek-char read-char is-space))
@@ -810,11 +827,81 @@
 	o=set(s,o);
 	if(!o) return(1);
 	DECREF(o);
-// (define (macro-doublequote stream) (let ((c 0) (i 0) (string (new-string 512))) (loop (if (= i (string-length string)) (set string (expand-string string))) (set c (catch 'end-of-file (read-char stream) (throw 'reader-error stream))) (if (= c 34) (exit-loop)) (if (= c 92) (set c (catch 'end-of-file (read-char stream) (throw 'reader-error stream)))) (put-char string i c) (set i (+ i 1))) (substring string 0 i)))
-// (#define 'macro-doublequote (byte-compile '(stream) '(#let 'c 0 '(#let 'i 0 '(#let 'string (new-string 512) '(#prog2of2 (#loop '(#prog2of2 (#ifelse (= i (string-length string)) '(#set 'string (expand-string string)) '#f) '(#prog2of2 (#set 'c (#catch 'end-of-file '(read-char stream) '(throw 'reader-error stream))) '(#prog2of2 (#ifelse (= c 34) '(#exit-loop #f) '#f) '(#prog2of2 (#ifelse (= c 92) '(#set 'c (#catch 'end-of-file '(read-char stream) '(throw 'reader-error stream))) '#f) '(#prog2of2 (put-char string i c) '(#set 'i (+ i 1)))))))) '(substring string 0 i)))))))
-// (#lambda "\x81#ii\x84\x80iLl\x81\x43\x81I\x81I\x81Ll\x81\x43\x82?\x8B\x46I\x82Ll\x81\x43I\x81P\x81G0D\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:I\x83PD\x82I\xA2i\x82?\x86\x46\x30\x80\xC5G\x81G0D\x82I\x80\xDCi\x82?\x9F\x46\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:I\x83P\x81G0DI\x82I\x84I\x86Ll\x83\x43\x44\x81I\x81i+I\x82PD\xFE\xF7GDIi\x83I\x87Ll\x83\x43PPP\x81R" '(new-string string-length expand-string read-char end-of-file reader-error put-char substring))
-// (#lambda "\x81#ii\x84\x80iLl\x81\x43\x81I\x81I\x81Ll\x81\x43\x82?\x87\x46I\x82Ll\x81\x43P\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:\x82P\x82I\xA2i\x82?\xBAT\x82I\x80\xDCi\x82?\x9C\x46\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:\x82PI\x82I\x84I\x86Ll\x83\x43\x44\x81I\x81i+\x81P\xFF\x8EGIi\x83I\x87Ll\x83\x43PPPPR" '(new-string string-length expand-string read-char end-of-file reader-error put-char substring))
-	s=new_string("\x81#ii\x84\x80iLl\x81\x43\x81I\x81I\x81Ll\x81\x43\x82?\x87\x46I\x82Ll\x81\x43P\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:\x82P\x82I\xA2i\x82?\xBAT\x82I\x80\xDCi\x82?\x9C\x46\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:\x82PI\x82I\x84I\x86Ll\x83\x43\x44\x81I\x81i+\x81P\xFF\x8EGIi\x83I\x87Ll\x83\x43PPPPR",139);
+// (define (subsubmacro-doublequote-backslash-x stream) (let ((c (hexchar? (catch 'end-of-file (peek-char stream) (throw 'reader-error stream))))) (unless c (throw 'reader-error stream)) (read-char stream) (catch 'end-of-file (let ((c2 (hexchar? (peek-char stream)))) (if c2 (read-char stream) (set c (+ (* c 16) c2)))) #f) c))
+// (#define 'subsubmacro-doublequote-backslash-x (byte-compile '(stream) '(#let 'c (hexchar? (#catch 'end-of-file '(peek-char stream) '(throw 'reader-error stream))) '(#prog2of2 (#ifelse c '#f '(throw 'reader-error stream)) '(#prog2of2 (read-char stream) '(#prog2of2 (#catch 'end-of-file '(#let 'c2 (hexchar? (peek-char stream)) '(#ifelse c2 '(#prog2of2 (read-char stream) '(#set 'c (+ (* c 16) c2))) '#f)) '#f) 'c))))))
+// (#lambda "\x81#\x88{ILl\x81\x43}\x8DG\x81L1=\x83T21:I\x82L:\x83Ll\x81\x43I\x83\x46\x30\x85G\x81I\x82L:D\x81I\x84Ll\x81\x43\x44\xA8{\x81ILl\x81\x43\x83Ll\x81\x43I\x95\x46\x82I\x84Ll\x81\x43\x44\x81I\x90i*\x81I+I\x82P\x81G0P}\x8AG\x81L1=\x83T21:0DIP\x81R" '(peek-char end-of-file reader-error hexchar? read-char))
+// (#lambda "\x81#\x88{ILl\x81\x43}\x8DG\x81L1=\x83T21:I\x82L:\x83Ll\x81\x43I\x85T\x81I\x82L:\x81I\x84Ll\x81\x43\x44\xA9{\x81ILl\x81\x43\x83Ll\x81\x43I\x95\x46\x82I\x84Ll\x81\x43\x44\x81I\x90i*\x81I+I\x82P\x81G0P}DPR\x81L1=\x83T21:PR" '(peek-char end-of-file reader-error hexchar? read-char))
+	s=new_string("\x81#\x88{ILl\x81\x43}\x8DG\x81L1=\x83T21:I\x82L:\x83Ll\x81\x43I\x85T\x81I\x82L:\x81I\x84Ll\x81\x43\x44\xA9{\x81ILl\x81\x43\x83Ll\x81\x43I\x95\x46\x82I\x84Ll\x81\x43\x44\x81I\x90i*\x81I+I\x82P\x81G0P}DPR\x81L1=\x83T21:PR",100);
+	if(!s) return(1);
+	c=INCREF(&nilobj);
+	o=new_word("read-char",9);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_word("hexchar?",8);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_word("reader-error",12);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_word("end-of-file",11);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_word("peek-char",9);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_object(&bytefunc_objtype);
+	if(!o) return(1);
+	o->value.bytefunc.code=s;
+	o->value.bytefunc.objs=c;
+	s=new_word("subsubmacro-doublequote-backslash-x",35);
+	if(!s) return(1);
+	o=define(s,o);
+	if(!o) return(1);
+	DECREF(o);
+
+// (define (submacro-doublequote-backslash stream) (let ((c (catch 'end-of-file (read-char stream) (throw 'reader-error stream)))) (ifelse (= 120 c) (subsubmacro-doublequote-backslash-x stream) c)))
+// (#define 'submacro-doublequote-backslash (byte-compile '(stream) '(#let 'c (#catch 'end-of-file '(read-char stream) '(throw 'reader-error stream)) '(#ifelse (= 120 c) '(subsubmacro-doublequote-backslash-x stream) 'c))))
+// (#lambda "\x81#\x88{ILl\x81\x43}\x8DG\x81L1=\x83T21:I\x82L:\x80\xF8i\x81I\x82?\x89\x46\x81I\x83Ll\x81\x43\x81GIP\x81R" '(read-char end-of-file reader-error subsubmacro-doublequote-backslash-x))
+// (#lambda "\x81#\x88{ILl\x81\x43}\x8DG\x81L1=\x83T21:I\x82L:\x80\xF8i\x81I\x82?\x89\x46\x81I\x83Ll\x81\x43\x81GIPPR" '(read-char end-of-file reader-error subsubmacro-doublequote-backslash-x))
+	s=new_string("\x81#\x88{ILl\x81\x43}\x8DG\x81L1=\x83T21:I\x82L:\x80\xF8i\x81I\x82?\x89\x46\x81I\x83Ll\x81\x43\x81GIPPR",47);
+	if(!s) return(1);
+	c=INCREF(&nilobj);
+	o=new_word("subsubmacro-doublequote-backslash-x",35);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_word("reader-error",12);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_word("end-of-file",11);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_word("read-char",9);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
+	o=new_object(&bytefunc_objtype);
+	if(!o) return(1);
+	o->value.bytefunc.code=s;
+	o->value.bytefunc.objs=c;
+	s=new_word("submacro-doublequote-backslash",30);
+	if(!s) return(1);
+	o=define(s,o);
+	if(!o) return(1);
+	DECREF(o);
+
+// (define (macro-doublequote stream) (let ((c #f) (i 0) (string (new-string 512))) (loop (if (= i (string-length string)) (set string (expand-string string))) (set c (catch 'end-of-file (read-char stream) (throw 'reader-error stream))) (if (= c 34) (exit-loop)) (if (= c 92) (set c (submacro-doublequote-backslash stream))) (put-char string i c) (set i (+ i 1))) (substring string 0 i)))
+// (#define 'macro-doublequote (byte-compile '(stream) '(#let 'c #f '(#let 'i 0 '(#let 'string (new-string 512) '(#prog2of2 (#loop '(#prog2of2 (#ifelse (= i (string-length string)) '(#set 'string (expand-string string)) '#f) '(#prog2of2 (#set 'c (#catch 'end-of-file '(read-char stream) '(throw 'reader-error stream))) '(#prog2of2 (#ifelse (= c 34) '(#exit-loop #f) '#f) '(#prog2of2 (#ifelse (= c 92) '(#set 'c (submacro-doublequote-backslash stream)) '#f) '(#prog2of2 (put-char string i c) '(#set 'i (+ i 1)))))))) '(substring string 0 i)))))))
+// (#lambda "\x81#0i\x84\x80iLl\x81\x43\x81I\x81I\x81Ll\x81\x43\x82?\x8B\x46I\x82Ll\x81\x43I\x81P\x81G0D\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:I\x83PD\x82I\xA2i\x82?\x85\x46\x30\xB2G\x81G0D\x82I\x80\xDCi\x82?\x8C\x46\x83I\x86Ll\x81\x43I\x83P\x81G0DI\x82I\x84I\x87Ll\x83\x43\x44\x81I\x81i+I\x82PD\xFF\x8BGDIi\x83I\x88Ll\x83\x43PPP\x81R" '(new-string string-length expand-string read-char end-of-file reader-error submacro-doublequote-backslash put-char substring))
+// (#lambda "\x81#0i\x84\x80iLl\x81\x43\x81I\x81I\x81Ll\x81\x43\x82?\x87\x46I\x82Ll\x81\x43P\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:\x82P\x82I\xA2i\x82?\xA7T\x82I\x80\xDCi\x82?\x89\x46\x83I\x86Ll\x81\x43\x82PI\x82I\x84I\x87Ll\x83\x43\x44\x81I\x81i+\x81P\xFF\xA1GIi\x83I\x88Ll\x83\x43PPPPR" '(new-string string-length expand-string read-char end-of-file reader-error submacro-doublequote-backslash put-char substring))
+	s=new_string("\x81#0i\x84\x80iLl\x81\x43\x81I\x81I\x81Ll\x81\x43\x82?\x87\x46I\x82Ll\x81\x43P\x8A{\x83I\x83Ll\x81\x43}\x8EG\x84L1=\x83T21:\x83I\x85L:\x82P\x82I\xA2i\x82?\xA7T\x82I\x80\xDCi\x82?\x89\x46\x83I\x86Ll\x81\x43\x82PI\x82I\x84I\x87Ll\x83\x43\x44\x81I\x81i+\x81P\xFF\xA1GIi\x83I\x88Ll\x83\x43PPPPR",120);
 	if(!s) return(1);
 	c=INCREF(&nilobj);
 	o=new_word("substring",9);
@@ -825,6 +912,10 @@
 	if(!o) return(1);
 	c=cons(o,c);
 	if(!c) return(1);
+	o=new_word("submacro-doublequote-backslash",30);
+	if(!o) return(1);
+	c=cons(o,c);
+	if(!c) return(1);
 	o=new_word("reader-error",12);
 	if(!o) return(1);
 	c=cons(o,c);
@@ -883,8 +974,8 @@
 // (define (read-token stream c) (let ((buffer (new-string 512)) (i 0)) (loop (if (= i (string-length buffer)) (set buffer (expand-string buffer))) (put-char buffer i c) (set i (+ i 1)) (catch 'end-of-file (set c (peek-char stream)) (exit-loop)) (if (is-space c) (exit-loop)) (unless (is-ascii c) (exit-loop)) (if (get-using-= #character-macros c) (exit-loop)) (set c (read-char stream))) (set buffer (substring buffer 0 i)) (ifelse (string-eqv? buffer "#f") #f (catch 'type-error (string->integer buffer) (string->symbol buffer)))))
 // (#define 'read-token (byte-compile '(stream c) '(#let 'buffer (new-string 512) '(#let 'i 0 '(#prog2of2 (#loop '(#prog2of2 (#ifelse (= i (string-length buffer)) '(#set 'buffer (expand-string buffer)) '#f) '(#prog2of2 (put-char buffer i c) '(#prog2of2 (#set 'i (+ i 1)) '(#prog2of2 (#catch 'end-of-file '(#set 'c (peek-char stream)) '(#exit-loop #f)) '(#prog2of2 (#ifelse (is-space c) '(#exit-loop #f) '#f) '(#prog2of2 (#ifelse (is-ascii c) '#f '(#exit-loop #f)) '(#prog2of2 (#ifelse (get-using-= #character-macros c) '(#exit-loop #f) '#f) '(#set 'c (read-char stream)))))))))) '(#prog2of2 (#set 'buffer (substring buffer 0 i)) '(#ifelse (string-eqv? buffer "#f") '#f '(#catch 'type-error '(string->integer buffer) '(string->symbol buffer)))))))))
 // (#lambda "\x82#\x84\x80iLl\x81\x43iI\x82I\x81Ll\x81\x43\x82?\x8C\x46\x81I\x82Ll\x81\x43I\x82P\x81G0D\x81I\x81I\x84I\x83Ll\x83\x43\x44I\x81i+I\x81PD\x8D{\x83I\x84Ll\x81\x43I\x83P}\x8DG\x85L1=\x83T21:0\x80\xC2GD\x82I\x86Ll\x81\x43\x85\x46\x30\xB5G\x81G0D\x82I\x87Ll\x81\x43\x83\x46\x30\x83G0\xA2GD\x88Ll\x83I\x89Ll\x82\x43\x85\x46\x30\x92G\x81G0D\x83I\x8ALl\x81\x43I\x83PD\xFE\xF4GD\x81Ii\x82I\x8BLl\x83\x43I\x82PD\x81I\x8CL\x8DLl\x82\x43\x83\x46\x30\x9CG\x8A{\x81I\x8ELl\x81\x43}\x90G\x8FL1=\x83T21:\x81I\x90Ll\x81\x43PP\x82R" '(new-string string-length expand-string put-char peek-char end-of-file is-space is-ascii #character-macros get-using-= read-char substring "#f" string-eqv? string->integer type-error string->symbol))
-// (#lambda "\x82#\x84\x80iLl\x81\x43iI\x82I\x81Ll\x81\x43\x82?\x89\x46\x81I\x82Ll\x81\x43\x81P\x81I\x81I\x84I\x83Ll\x83\x43\x44I\x81i+P\x8E{\x83I\x84Ll\x81\x43I\x83P}D\x8BG\x85L1=\x83T21:\xAAG\x82I\x86Ll\x81\x43\xA1T\x82I\x87Ll\x81\x43\x98\x46\x88Ll\x83I\x89Ll\x82\x43\x8CT\x83I\x8ALl\x81\x43\x82P\xFF\x95G\x81Ii\x82I\x8BLl\x83\x43\x81P\x81I\x8CL\x8DLl\x82\x43\x83\x46\x30\x9CG\x8A{\x81I\x8ELl\x81\x43}\x90G\x8FL1=\x83T21:\x81I\x90Ll\x81\x43PP\x81PDR" '(new-string string-length expand-string put-char peek-char end-of-file is-space is-ascii #character-macros get-using-= read-char substring "#f" string-eqv? string->integer type-error string->symbol))
-	s=new_string("\x82#\x84\x80iLl\x81\x43iI\x82I\x81Ll\x81\x43\x82?\x89\x46\x81I\x82Ll\x81\x43\x81P\x81I\x81I\x84I\x83Ll\x83\x43\x44I\x81i+P\x8E{\x83I\x84Ll\x81\x43I\x83P}D\x8BG\x85L1=\x83T21:\xAAG\x82I\x86Ll\x81\x43\xA1T\x82I\x87Ll\x81\x43\x98\x46\x88Ll\x83I\x89Ll\x82\x43\x8CT\x83I\x8ALl\x81\x43\x82P\xFF\x95G\x81Ii\x82I\x8BLl\x83\x43\x81P\x81I\x8CL\x8DLl\x82\x43\x83\x46\x30\x9CG\x8A{\x81I\x8ELl\x81\x43}\x90G\x8FL1=\x83T21:\x81I\x90Ll\x81\x43PP\x81PDR",177);
+// (#lambda "\x82#\x84\x80iLl\x81\x43iI\x82I\x81Ll\x81\x43\x82?\x89\x46\x81I\x82Ll\x81\x43\x81P\x81I\x81I\x84I\x83Ll\x83\x43\x44\x81i+\x8E{\x83I\x84Ll\x81\x43I\x83P}D\x8BG\x85L1=\x83T21:\xAAG\x82I\x86Ll\x81\x43\xA1T\x82I\x87Ll\x81\x43\x98\x46\x88Ll\x83I\x89Ll\x82\x43\x8CT\x83I\x8ALl\x81\x43\x82P\xFF\x97G\x81Ii\x82I\x8BLl\x83\x43\x81P\x81I\x8CL\x8DLl\x82\x43\x83\x46\x30\x9CG\x8A{\x81I\x8ELl\x81\x43}\x90G\x8FL1=\x83T21:\x81I\x90Ll\x81\x43PP\x81PDR" '(new-string string-length expand-string put-char peek-char end-of-file is-space is-ascii #character-macros get-using-= read-char substring "#f" string-eqv? string->integer type-error string->symbol))
+	s=new_string("\x82#\x84\x80iLl\x81\x43iI\x82I\x81Ll\x81\x43\x82?\x89\x46\x81I\x82Ll\x81\x43\x81P\x81I\x81I\x84I\x83Ll\x83\x43\x44\x81i+\x8E{\x83I\x84Ll\x81\x43I\x83P}D\x8BG\x85L1=\x83T21:\xAAG\x82I\x86Ll\x81\x43\xA1T\x82I\x87Ll\x81\x43\x98\x46\x88Ll\x83I\x89Ll\x82\x43\x8CT\x83I\x8ALl\x81\x43\x82P\xFF\x97G\x81Ii\x82I\x8BLl\x83\x43\x81P\x81I\x8CL\x8DLl\x82\x43\x83\x46\x30\x9CG\x8A{\x81I\x8ELl\x81\x43}\x90G\x8FL1=\x83T21:\x81I\x90Ll\x81\x43PP\x81PDR",175);
 	if(!s) return(1);
 	c=INCREF(&nilobj);
 	o=new_word("string->symbol",14);
@@ -1109,8 +1200,8 @@
 // (define (string-eqv? a b) (let ((c (string-length a))) (ifelse (= c (string-length b)) (loop (if (= c 0) (exit-loop #t)) (set c (- c 1)) (if (<> (get-char a c) (get-char b c)) (exit-loop #f))) #f)))
 // (#define 'string-eqv? (byte-compile '(a b) '(#let 'c (string-length a) '(#ifelse (= c (string-length b)) '(#loop '(#prog2of2 (#ifelse (= c 0) '(#exit-loop #t) '#f) '(#prog2of2 (#set 'c (- c 1)) '(#ifelse (<> (get-char a c) (get-char b c)) '(#exit-loop #f) '#f)))) '#f))))
 // (#lambda "\x82#\x81ILl\x81\x43I\x82ILl\x81\x43\x82?\xB7\x46Ii\x82?\x86\x46\x30!\xABG\x81G0DI\x81i-I\x81PD\x82I\x81I\x81Ll\x82\x43\x82I\x82I\x81Ll\x82\x43\x85?\x85\x46\x30\x86G\x81G0D\xCBG\x81G0P\x82R" '(string-length get-char))
-// (#lambda "\x82#\x81ILl\x81\x43I\x82ILl\x81\x43\x82?\xAA\x46Ii\x82?\x84\x46\x30!\xA1GI\x81i-P\x82I\x81I\x81Ll\x82\x43\x82I\x82I\x81Ll\x82\x43\x85?\x83\x46\x30\x83G\xD6G0P\x81PDR" '(string-length get-char))
-	s=new_string("\x82#\x81ILl\x81\x43I\x82ILl\x81\x43\x82?\xAA\x46Ii\x82?\x84\x46\x30!\xA1GI\x81i-P\x82I\x81I\x81Ll\x82\x43\x82I\x82I\x81Ll\x82\x43\x85?\x83\x46\x30\x83G\xD6G0P\x81PDR",67);
+// (#lambda "\x82#\x81ILl\x81\x43I\x82ILl\x81\x43\x82?\xA8\x46Ii\x82?\x84\x46\x30!\x9FG\x81i-\x82I\x81I\x81Ll\x82\x43\x82I\x82I\x81Ll\x82\x43\x85?\x83\x46\x30\x83G\xD8G0P\x81PDR" '(string-length get-char))
+	s=new_string("\x82#\x81ILl\x81\x43I\x82ILl\x81\x43\x82?\xA8\x46Ii\x82?\x84\x46\x30!\x9FG\x81i-\x82I\x81I\x81Ll\x82\x43\x82I\x82I\x81Ll\x82\x43\x85?\x83\x46\x30\x83G\xD8G0P\x81PDR",65);
 	if(!s) return(1);
 	c=INCREF(&nilobj);
 	o=new_word("get-char",8);
@@ -1175,8 +1266,8 @@
 // (define (concatenate-strings list) (let ((l list) (i 0)) (while l (set i (+ i (string-length (car l)))) (set l (cdr l))) (let ((s (new-string i))) (set i 0) (while list (let ((j 0)) (while (< j (string-length (car list))) (put-char s i (get-char (car list) j)) (set i (+ i 1)) (set j (+ j 1)))) (set list (cdr list))) s)))
 // (#define 'concatenate-strings (byte-compile '(list) '(#let 'l list '(#let 'i 0 '(#prog2of2 (#loop '(#ifelse l '(#prog2of2 (#set 'i (+ i (string-length (car l)))) '(#set 'l (cdr l))) '(#exit-loop #f))) '(#let 's (new-string i) '(#prog2of2 (#set 'i 0) '(#prog2of2 (#loop '(#ifelse list '(#prog2of2 (#let 'j 0 '(#loop '(#ifelse (< j (string-length (car list))) '(#prog2of2 (put-char s i (get-char (car list) j)) '(#prog2of2 (#set 'i (+ i 1)) '(#set 'j (+ j 1)))) '(#exit-loop #f)))) '(#set 'list (cdr list))) '(#exit-loop #f))) 's))))))))
 // (#lambda "\x81#Ii\x81I\x95\x46I\x82IaLl\x81\x43+I\x81PD\x81IdI\x82P\x83G0\x83GD\xE1GDI\x81Ll\x81\x43iI\x82PD\x83I\x80\xC3\x46iI\x85IaLl\x81\x43\x81?\xA6\x46\x81I\x83I\x86Ia\x83I\x82Ll\x82\x43\x83Ll\x83\x43\x44\x82I\x81i+I\x83PDI\x81i+I\x81P\x83G0\x83GD\xC8GPD\x83IdI\x84P\x83G0\x84GD\xFF\xB1GDIPPP\x81R" '(string-length new-string get-char put-char))
-// (#lambda "\x81#Ii\x81I\x91\x46I\x82IaLl\x81\x43+P\x81Id\x81P\xEBGI\x81Ll\x81\x43i\x81P\x83I\xB7\x46iI\x85IaLl\x81\x43\x81?\xA2\x46\x81I\x83I\x86Ia\x83I\x82Ll\x82\x43\x83Ll\x83\x43\x44\x82I\x81i+\x82PI\x81i+P\xD2GD\x83Id\x83P\xC5GPPPR" '(string-length new-string get-char put-char))
-	s=new_string("\x81#Ii\x81I\x91\x46I\x82IaLl\x81\x43+P\x81Id\x81P\xEBGI\x81Ll\x81\x43i\x81P\x83I\xB7\x46iI\x85IaLl\x81\x43\x81?\xA2\x46\x81I\x83I\x86Ia\x83I\x82Ll\x82\x43\x83Ll\x83\x43\x44\x82I\x81i+\x82PI\x81i+P\xD2GD\x83Id\x83P\xC5GPPPR",97);
+// (#lambda "\x81#Ii\x81I\x91\x46I\x82IaLl\x81\x43+P\x81Id\x81P\xEBGI\x81Ll\x81\x43i\x81P\x83I\xB5\x46iI\x85IaLl\x81\x43\x81?\xA0\x46\x81I\x83I\x86Ia\x83I\x82Ll\x82\x43\x83Ll\x83\x43\x44\x82I\x81i+\x82P\x81i+\xD4GD\x83Id\x83P\xC7GPPPR" '(string-length new-string get-char put-char))
+	s=new_string("\x81#Ii\x81I\x91\x46I\x82IaLl\x81\x43+P\x81Id\x81P\xEBGI\x81Ll\x81\x43i\x81P\x83I\xB5\x46iI\x85IaLl\x81\x43\x81?\xA0\x46\x81I\x83I\x86Ia\x83I\x82Ll\x82\x43\x83Ll\x83\x43\x44\x82I\x81i+\x82P\x81i+\xD4GD\x83Id\x83P\xC7GPPPR",95);
 	if(!s) return(1);
 	c=INCREF(&nilobj);
 	o=new_word("put-char",8);
@@ -1296,8 +1387,8 @@
 // (define (list-length a) (let ((len 0)) (while a (set len (+ len 1)) (set a (cdr a))) len))
 // (#define 'list-length (byte-compile '(a) '(#let 'len 0 '(#prog2of2 (#loop '(#ifelse a '(#prog2of2 (#set 'len (+ len 1)) '(#set 'a (cdr a))) '(#exit-loop #f))) 'len))))
 // (#lambda "\x81#i\x81I\x90\x46I\x81i+I\x81PD\x81IdI\x82P\x83G0\x83GD\xE6GDIP\x81R" '#f)
-// (#lambda "\x81#i\x81I\x8C\x46I\x81i+P\x81Id\x81P\xF0GPR" '#f)
-	s=new_string("\x81#i\x81I\x8C\x46I\x81i+P\x81Id\x81P\xF0GPR",21);
+// (#lambda "\x81#i\x81I\x8A\x46\x81i+\x81Id\x81P\xF2GPR" '#f)
+	s=new_string("\x81#i\x81I\x8A\x46\x81i+\x81Id\x81P\xF2GPR",19);
 	if(!s) return(1);
 	c=INCREF(&nilobj);
 	o=new_object(&bytefunc_objtype);
@@ -1313,8 +1404,8 @@
 // (define (nth-item list n) (while (< 0 n) (set list (cdr list)) (set n (- n 1))) (car list))
 // (#define 'nth-item (byte-compile '(list n) '(#prog2of2 (#loop '(#ifelse (< 0 n) '(#prog2of2 (#set 'list (cdr list)) '(#set 'n (- n 1))) '(#exit-loop #f))) '(car list))))
 // (#lambda "\x82#i\x81I\x81?\x90\x46\x81IdI\x82PDI\x81i-I\x81P\x83G0\x83GD\xE3GD\x81Ia\x82R" '#f)
-// (#lambda "\x82#i\x81I\x81?\x8C\x46\x81Id\x81PI\x81i-P\xEDG\x81Ia\x81PDR" '#f)
-	s=new_string("\x82#i\x81I\x81?\x8C\x46\x81Id\x81PI\x81i-P\xEDG\x81Ia\x81PDR",28);
+// (#lambda "\x82#i\x81I\x81?\x8A\x46\x81Id\x81P\x81i-\xEFG\x81Ia\x81PDR" '#f)
+	s=new_string("\x82#i\x81I\x81?\x8A\x46\x81Id\x81P\x81i-\xEFG\x81Ia\x81PDR",26);
 	if(!s) return(1);
 	c=INCREF(&nilobj);
 	o=new_object(&bytefunc_objtype);
@@ -1330,8 +1421,8 @@
 // (define (list-index list item) (let ((i 0)) (while list (if (eq? item (car list)) (exit-loop i)) (set i (+ i 1)) (set list (cdr list)))))
 // (#define 'list-index (byte-compile '(list item) '(#let 'i 0 '(#loop '(#ifelse list '(#prog2of2 (#ifelse (eq? item (car list)) '(#exit-loop i) '#f) '(#prog2of2 (#set 'i (+ i 1)) '(#set 'list (cdr list)))) '(#exit-loop #f))))))
 // (#lambda "\x82#i\x82I\x9F\x46\x81I\x83Ia=\x85\x46I\x9AG\x81G0DI\x81i+I\x81PD\x82IdI\x83P\x83G0\x83GD\xD7GP\x82R" '#f)
-// (#lambda "\x82#i\x82I\x97\x46\x81I\x83Ia=\x83\x46I\x8DGI\x81i+P\x82Id\x82P\xE5G0P\x81PDR" '#f)
-	s=new_string("\x82#i\x82I\x97\x46\x81I\x83Ia=\x83\x46I\x8DGI\x81i+P\x82Id\x82P\xE5G0P\x81PDR",36);
+// (#lambda "\x82#i\x82I\x95\x46\x81I\x83Ia=\x83\x46I\x8BG\x81i+\x82Id\x82P\xE7G0P\x81PDR" '#f)
+	s=new_string("\x82#i\x82I\x95\x46\x81I\x83Ia=\x83\x46I\x8BG\x81i+\x82Id\x82P\xE7G0P\x81PDR",34);
 	if(!s) return(1);
 	c=INCREF(&nilobj);
 	o=new_object(&bytefunc_objtype);
@@ -1529,9 +1620,9 @@
 
 // (define (read-eval-print in out prompt) (let ((o #f)) (loop (if prompt (write-string out prompt)) (set o (catch 'end-of-file (catch 'reader-error (read-object in) (progn (show-error #exception #exceptionvalue) (ifelse prompt (next-loop) (exit-loop #t)))) (progn (if prompt (write-newline out)) (exit-loop)))) (set o (catch #f ((byte-compile #f (macro-expand o))) (progn (show-error #exception #exceptionvalue) (ifelse prompt (next-loop) (exit-loop #t))))) (if (and prompt o) (write-object out o) (write-newline out)))))
 // (#define 'read-eval-print (byte-compile '(in out prompt) '(#let 'o #f '(#loop '(#prog2of2 (#ifelse prompt '(write-string out prompt) '#f) '(#prog2of2 (#set 'o (#catch 'end-of-file '(#catch 'reader-error '(read-object in) '(#prog2of2 (show-error #exception #exceptionvalue) '(#ifelse prompt '(#next-loop) '(#exit-loop #t)))) '(#prog2of2 (#ifelse prompt '(write-newline out) '#f) '(#exit-loop #f)))) '(#prog2of2 (#set 'o (#catch #f '((byte-compile #f (macro-expand o))) '(#prog2of2 (show-error #exception #exceptionvalue) '(#ifelse prompt '(#next-loop) '(#exit-loop #t))))) '(#ifelse (#and prompt 'o) '(#prog2of2 (write-object out o) '(write-newline out)) '#f))))))))
-// (#lambda "\x83#0\x81I\x8A\x46\x82I\x82ILl\x82\x43\x81G0D\xAD{\x8A{\x83I\x81Ll\x81\x43}\x9EG\x82L1=\x83T21:12\x83Ll\x82\x43\x44\x81I\x84\x46\xCBG\x85G0!\x80\xF0G}\x9CG\x84L1=\x83T21:\x81I\x89\x46\x82I\x85Ll\x81\x43\x81G0D0\x80\xD1GI\x81PD\x91{0\x81I\x86Ll\x81\x43\x87Ll\x82\x43\x43}\x95G12\x83Ll\x82\x43\x44\x81I\x85\x46\xFE\xFFG\x84G0!\xA5GI\x81PD\x81II\x82\x46\x44I\x93\x46\x82I\x81I\x88Ll\x82\x43\x44\x82I\x85Ll\x81\x43\x81G0D\xFE\xD4GP\x83R" '(write-string read-object reader-error show-error end-of-file write-newline macro-expand byte-compile write-object))
-// (#lambda "\x83#0\x81I\x89\x46\x82I\x82ILl\x82\x43\x44\xA9{\x8A{\x83I\x81Ll\x81\x43}\x9AG\x82L1=\x83T21:12\x83Ll\x82\x43\x44\x81I\xD0T0!\x80\xE3G}\x99G\x84L1=\x83T21:\x81I\x88\x46\x82I\x85Ll\x81\x43\x44\x30\x80\xC7GP\x91{0\x81I\x86Ll\x81\x43\x87Ll\x82\x43\x43}\x91G12\x83Ll\x82\x43\x44\x81I\xFF\x8ET0!\xA2GP\x81II\x82\x46\x44I\x95\x46\x82I\x81I\x88Ll\x82\x43\x44\x82I\x85Ll\x81\x43\x44\xFE\xEBG\xFE\xE8GP\x82P\x81\x44R" '(write-string read-object reader-error show-error end-of-file write-newline macro-expand byte-compile write-object))
-	s=new_string("\x83#0\x81I\x89\x46\x82I\x82ILl\x82\x43\x44\xA9{\x8A{\x83I\x81Ll\x81\x43}\x9AG\x82L1=\x83T21:12\x83Ll\x82\x43\x44\x81I\xD0T0!\x80\xE3G}\x99G\x84L1=\x83T21:\x81I\x88\x46\x82I\x85Ll\x81\x43\x44\x30\x80\xC7GP\x91{0\x81I\x86Ll\x81\x43\x87Ll\x82\x43\x43}\x91G12\x83Ll\x82\x43\x44\x81I\xFF\x8ET0!\xA2GP\x81II\x82\x46\x44I\x95\x46\x82I\x81I\x88Ll\x82\x43\x44\x82I\x85Ll\x81\x43\x44\xFE\xEBG\xFE\xE8GP\x82P\x81\x44R",161);
+// (#lambda "\x83#0\x81I\x8A\x46\x82I\x82ILl\x82\x43\x81G0D\xAF{\x8A{\x83I\x81Ll\x81\x43}\xA0G\x82L1=\x83T21:12\x83Ll\x82\x43\x44\x81I\x85\x46}\xCAG\x86G0!}\x80\xF0G}\x9CG\x84L1=\x83T21:\x81I\x89\x46\x82I\x85Ll\x81\x43\x81G0D0\x80\xD1GI\x81PD\x91{0\x81I\x86Ll\x81\x43\x87Ll\x82\x43\x43}\x95G12\x83Ll\x82\x43\x44\x81I\x85\x46\xFE\xFDG\x84G0!\xA5GI\x81PD\x81II\x82\x46\x44I\x93\x46\x82I\x81I\x88Ll\x82\x43\x44\x82I\x85Ll\x81\x43\x81G0D\xFE\xD2GP\x83R" '(write-string read-object reader-error show-error end-of-file write-newline macro-expand byte-compile write-object))
+// (#lambda "\x83#0\x81I\x89\x46\x82I\x82ILl\x82\x43\x44\xAD{\x8A{\x83I\x81Ll\x81\x43}\x9EG\x82L1=\x83T21:12\x83Ll\x82\x43\x44\x81I\x83\x46}\xCDG0!}\x80\xE3G}\x99G\x84L1=\x83T21:\x81I\x88\x46\x82I\x85Ll\x81\x43\x44\x30\x80\xC7GP\x91{0\x81I\x86Ll\x81\x43\x87Ll\x82\x43\x43}\x91G12\x83Ll\x82\x43\x44\x81I\xFF\x8AT0!\xA2GP\x81II\x82\x46\x44I\x95\x46\x82I\x81I\x88Ll\x82\x43\x44\x82I\x85Ll\x81\x43\x44\xFE\xE7G\xFE\xE4GP\x82P\x81\x44R" '(write-string read-object reader-error show-error end-of-file write-newline macro-expand byte-compile write-object))
+	s=new_string("\x83#0\x81I\x89\x46\x82I\x82ILl\x82\x43\x44\xAD{\x8A{\x83I\x81Ll\x81\x43}\x9EG\x82L1=\x83T21:12\x83Ll\x82\x43\x44\x81I\x83\x46}\xCDG0!}\x80\xE3G}\x99G\x84L1=\x83T21:\x81I\x88\x46\x82I\x85Ll\x81\x43\x44\x30\x80\xC7GP\x91{0\x81I\x86Ll\x81\x43\x87Ll\x82\x43\x43}\x91G12\x83Ll\x82\x43\x44\x81I\xFF\x8AT0!\xA2GP\x81II\x82\x46\x44I\x95\x46\x82I\x81I\x88Ll\x82\x43\x44\x82I\x85Ll\x81\x43\x44\xFE\xE7G\xFE\xE4GP\x82P\x81\x44R",165);
 	if(!s) return(1);
 	c=INCREF(&nilobj);
 	o=new_word("write-object",12);
